# -*- coding: utf-8 -*-
# ------- 全局配置 - 开始 ------- 
import sys
reload(sys)
sys.setdefaultencoding('utf8')
import os
import time
import oss2
import json
import subprocess
import logging
import io
from resource import bagtocsv_robot
from utils import json_utils
path1 = '/mnt/disk001/dcl_data_process/src/python2/pjibot/'
path2 = '/mnt/disk001/run' # 生成评价报告pdf的可执行文件路径
path3 = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor'
path4 = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor/filter_pos.py'
pgm_path = '/mnt/disk001/dcl_data_process/src/python3/pjibot_indoor/resource/shiyanshi_newpgm_20240416.pgm'
log_file_path = path1 + 'log/csv-pjibot_guide.log'
key1 = 'pjibot/'
sleep_time = 10  # 每多少秒扫描一次
error_bag_json = "/mnt/disk001/dcl_data_process/src/python2/pjibot/csv-errorBag.json"
logging.basicConfig(filename=log_file_path, level=logging.INFO,format='%(asctime)s - %(levelname)s - %(message)s')
# 1 创建阿里云对象
auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
bucket = oss2.Bucket(auth, endpoint, 'pji-bucket1')
# ------- 全局变量 - 结束 -------


# ------- 解析 csv 主要函数，调用 csv 解析脚本 -------
def parse_csv(costmap_bag, data_bag, parse_prefix, local_parse_dir, local_delete_list):
    try:
        bagtocsv_robot.parse(costmap_bag, data_bag, local_parse_dir + '/csv/')
        bagname = data_bag.split('/')[-1].split('.')[0]
        local_csv_dir = os.path.join(local_parse_dir + '/csv/', bagname)
        
        # ------- 上传 csv - 开始 -------
        csv_file_name1 = 'pos_pji'
        local_csv_file_path1 = str(local_csv_dir) + '/' + str(csv_file_name1) + '.csv'
        oss_csv_object_key1 = parse_prefix + csv_file_name1 + '.csv'
        if os.path.exists(local_csv_file_path1):
            bucket.put_object_from_file(oss_csv_object_key1, local_csv_file_path1)
            local_delete_list.append(local_csv_file_path1)
        else:
            logging.error("没有 pos_pji.csv")
            json_utils.add_error(parse_prefix,error_bag_json)

        csv_file_name2 = 'EgoState_pji'
        local_csv_file_path2 = str(local_csv_dir) + '/' + str(csv_file_name2) + '.csv'
        oss_csv_object_key2 = parse_prefix + csv_file_name2 + '.csv'
        if os.path.exists(local_csv_file_path2):
            bucket.put_object_from_file(oss_csv_object_key2, local_csv_file_path2)
            local_delete_list.append(local_csv_file_path2)
        else:
            logging.error("没有 EgoState_pji.csv")
            json_utils.add_error(parse_prefix,error_bag_json)
        
        csv_file_name3 = 'merged_obstacles'
        local_csv_file_path3 = str(local_csv_dir) + '/' + str(csv_file_name3) + '.csv'
        oss_csv_object_key3 = parse_prefix + csv_file_name3 + '.csv'
        if os.path.exists(local_csv_file_path3):
            bucket.put_object_from_file(oss_csv_object_key3, local_csv_file_path3)
            local_delete_list.append(local_csv_file_path3)
        else:
            logging.error("没有 merged_obstacles.csv")
            json_utils.add_error(parse_prefix,error_bag_json)
        # ------- 上传 csv - 结束 -------
        
        # ------- 处理 output.json - 开始 -------
        try:
            # 1 解析 output.json
            output_json_path = str(local_csv_dir)+'/output.json'
            if os.path.exists(output_json_path):
                outputs = json_utils.parse_json_to_string_array(output_json_path)
                # 2 将 output.json 添加到 callback.json 的 check 字段
                callback_json_oss_key = parse_prefix+'callback.json'
                callback_json_local = local_csv_dir+'/callback.json'
                bucket.get_object_to_file(callback_json_oss_key, callback_json_local)
                with io.open(callback_json_local, 'r', encoding='utf-8') as f:
                    data = json.load(f)
                if 'check' not in data:
                    data['check'] = []
                data['check'].extend(outputs)
                data['check'] = list(set(data['check']))
                json_data = json.dumps(data, ensure_ascii=False, indent=4)
                with io.open(callback_json_local, 'w', encoding='utf-8') as f:
                    f.write(unicode(json_data))
                bucket.put_object_from_file(callback_json_oss_key, callback_json_local)
        except Exception as e3:
            # todo 可能没有callback.json，已经处理成 callback_done.json了，暂时不管
            pass
        # ------- 处理 output.json - 结束 -------
        

        # ------- 生成 pdf 报告 - 开始 -------
        pdf_local_path = str(local_csv_dir) + '/report.pdf'
        track_png_key = parse_prefix + 'track.png'
        bucket.get_object_to_file(track_png_key, str(local_csv_dir) + '/track1.png')
        os.chdir(path2)
        command1 = './pji_single ' + str(local_csv_dir) + '/ ' + str(local_csv_dir) + '/ ' + str(local_csv_dir) + '/track1.png ' + data_bag.split('/')[-1].split('.')[0]
        logging.info("调用生成pdf 报告命令: %s" % str(command1))
        os.system(command1)
        if os.path.exists(pdf_local_path):
            bucket.put_object_from_file(parse_prefix + 'report.pdf',pdf_local_path)
            local_delete_list.append(pdf_local_path)
        else:
            logging.error("没有 report.pdf")
            json_utils.add_error(parse_prefix,error_bag_json)
        # ------- 生成 pdf 报告 - 结束 -------
        

        # ------- 根据 merged_obstacles 和 机器人指定的pgm文件 生成新的 merged_obstacles 文件 -------
        os.chdir(path3)
        command2 = "python2 {} {} {}".format(path4, pgm_path, local_csv_file_path3)
        logging.info("调用命令 merged_obstacles_new.csv 生成命令: %s", command2)
        process = subprocess.Popen(command2, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        stdout, stderr = process.communicate()  # 获取标准输出和错误输出
        if process.returncode == 0:
            logging.info("命令输出: %s", stdout)
        else:
            logging.error("命令执行失败，错误信息: %s", stderr)
        time.sleep(2)
        bucket.put_object_from_file(oss_csv_object_key3.replace('merged_obstacles', 'merged_obstacles_new'),local_csv_file_path3)  # 因为生成的文件是同名覆盖的
    except Exception as e2:
        logging.exception("生成csv报错: %s", e2)
        json_utils.add_error(parse_prefix,error_bag_json)


# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    while True:
        logging.info("开始新一轮扫描：%s " % key1)
        time.sleep(sleep_time)
        try:
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                # 获取合并后的包
                merged_bag_object_key = str(obj1.key)
                if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                    merged_bag_object_key_split = merged_bag_object_key.split('/')
                    merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                    parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                    parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                    csv1_done = False
                    csv2_done = False
                    csv3_done = False
                    pdf_done = False
                    for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                        if '/pos_pji.csv' in str(obj2.key):
                            csv1_done = True
                        if '/EgoState_pji.csv' in str(obj2.key):
                            csv2_done = True
                        if '/merged_obstacles.csv' in str(obj2.key):
                            csv3_done = True
                        if '/report.pdf' in str(obj2.key):
                            pdf_done = True
                    if csv1_done and csv2_done and csv3_done and pdf_done:
                        continue
                    error_bag_list = json_utils.parse_json_to_string_array(error_bag_json)
                    if parse_prefix_full in error_bag_list:
                        continue
                    logging.info("开始解析csv并生成评价报告: %s" % str(obj1.key))
                    local_merged_bag_path = path1 + 'camera/' + merged_bag_object_key
                    local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                    local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                    if not os.path.exists(local_merged_dir):
                        os.makedirs(local_merged_dir)
                    if not os.path.exists(local_parse_dir):
                        os.makedirs(local_parse_dir)
                    merged_bag_full_name = merged_bag_object_key_split[-1]
                    merged_bag_name = merged_bag_full_name.split('.')[0]
                    bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                    local_delete_list.append(local_merged_bag_path)
                    # 下载costmap.bag
                    costmap_key = merged_prefix.replace('data_merge', '') + 'costmap.bag'
                    logging.info("costmap.bag包的key为: %s" % str(costmap_key))
                    bucket.get_object_to_file(costmap_key, local_merged_dir + 'costmap.bag')
                    # 2 生成 pos_orig.csv 和 pos_hmi.csv
                    parse_csv(local_merged_dir + 'costmap.bag', local_merged_bag_path, parse_prefix_full,local_parse_dir, local_delete_list)

            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("捕获到一个异常: %s" % str(e))
        except Exception as e:
            logging.exception("全局错误处理: %s" % str(e))
